/*
   Copyright (C) 2000-2001  Ulric Eriksson <ulric@siag.nu>
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the Licence, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
 */

#include "config.h"

#ifdef HAVE_LIBSQLITE

/* Highly experimental! */

#include <stdio.h>
#include <stdlib.h>
#include <sqlite.h>
#include "common.h"
#include "sdb.h"

#define FAIL(db, msg) {\
	fprintf(stderr, "error '%s'\n", msg);\
	sqlite_close(db);\
	return -1;\
}

struct cb_data {
	int r;			/* row within query result */
	int (*callback)(int, char **, void *);
	void *closure;
};

static int store_result(void *data, int n, char **p, char **q)
{
	struct cb_data *cbd = (struct cb_data *)data;
	int (*callback)(int, char **, void *) = cbd->callback;
	void *closure = cbd->closure;

	(*callback)(n, p, closure);
	cbd->r++;
	return 0;
}

static int sqlite_driver(char *d, char *q,
	int (*callback)(int, char **, void *), void *closure)
{
	int n;
	sqlite *db;
	char *errmsg;
	struct cb_data cbd;
	char *database = sdb_url_value(d, "db");

	cbd.r = 0;
	cbd.callback = callback;
	cbd.closure = closure;
	db = sqlite_open(database, 0666, &errmsg);
	if (!db) FAIL(db, errmsg);
	n = sqlite_exec(db, q, store_result, &cbd, &errmsg);
	if (n != 0) FAIL(db, errmsg);
	sqlite_close(db);
	sdb_free(database);
	return cbd.r;
}

void sdb_init_sqlite(void)
{
	sdb_register_driver("sqlite", sqlite_driver);
}

#else

void sdb_init_sqlite(void)
{
	;
}

#endif	/* SQLITE */
